Bug 204055 - [patch] zfs(8) should not yet list edonr as supported hash algorithm
Summary: [patch] zfs(8) should not yet list edonr as supported hash algorithm
Status: Closed FIXED
Alias: None
Product: Base System
Classification: Unclassified
Component: bin (show other bugs)
Version: CURRENT
Hardware: Any Any
: --- Affects Only Me
Assignee: Ed Maste
URL:
Keywords: patch
Depends on:
Blocks:
 
Reported: 2015-10-27 13:42 UTC by Fabian Keil
Modified: 2018-05-23 14:04 UTC (History)
3 users (show)

See Also:
emaste: mfc-stable9-
emaste: mfc-stable10-
emaste: mfc-stable11?


Attachments
zfs(8): Do not advertise sha512, skein and edonr which aren't supported yet (1.62 KB, patch)
2015-10-27 13:42 UTC, Fabian Keil
no flags Details | Diff
zfs: Do not advertise edonr which isn't supported yet (2.00 KB, patch)
2017-08-29 13:41 UTC, Fabian Keil
no flags Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Fabian Keil 2015-10-27 13:42:38 UTC
Created attachment 162496 [details]
zfs(8): Do not advertise sha512, skein and edonr which aren't supported yet

illumos 4185 (add new cryptographic checksums to ZFS: SHA-512,
Skein, Edon-R) was intentionally merged only partially in r289422
and the algorithms actually are not yet supported on FreeBSD.

zfs(8) correctly rejects them, the error message claims that
they are supported, though:

fk@r500 ~ $zfs set checksum=edonr tank
cannot set property for 'tank': 'checksum' must be one of 'on | off | fletcher2 | fletcher4 | sha256 | sha512 | skein | edonr'

The attached patch fixes this.

Obtained from: ElectroBSD
Comment 1 Allan Jude freebsd_committer 2017-08-19 00:59:45 UTC
sha512 and skein are supported. edon-r is not.
Comment 2 Fabian Keil 2017-08-29 13:41:38 UTC
Created attachment 185880 [details]
zfs: Do not advertise edonr which isn't supported yet

skein and sha512 weren't supported in 2015 when the original patch was submitted.
The updated version only removes the edonr advertisement.
Comment 3 Fabian Keil 2017-08-29 13:43:22 UTC
Spelling is hard, title corrected.
Comment 4 commit-hook freebsd_committer 2017-08-29 22:25:25 UTC
A commit references this bug:

Author: emaste
Date: Tue Aug 29 22:24:22 UTC 2017
New revision: 323002
URL: https://svnweb.freebsd.org/changeset/base/323002

Log:
  zfs: do not advertise edonr which is not yet supported

  illumos 4185 ("add new cryptographic checksums to ZFS: SHA-512,
  Skein, Edon-R") was intentionally merged only partially in r289422,
  without adding support for skein, sha512 and edonr on FreeBSD.

  Support for skein and sha512 was added later on, but edonr is still not
  implemented in FreeBSD.

  Prior to this commit zfs(8) correctly rejected edonr, but with an error
  message that claimed support:

  fk@r500 ~ $zfs set checksum=edonr tank
  cannot set property for 'tank': 'checksum' must be one of 'on | off | fletcher2 | fletcher4 | sha256 | sha512 | skein | edonr'

  PR:		204055
  Submitted by:	Fabian Keil
  Approved by:	allanjude
  Obtained from:	ElectroBSD
  MFC after:	1 week

Changes:
  head/sys/cddl/contrib/opensolaris/common/zfs/zfs_prop.c
Comment 5 commit-hook freebsd_committer 2017-09-08 20:42:34 UTC
A commit references this bug:

Author: emaste
Date: Fri Sep  8 20:41:49 UTC 2017
New revision: 323331
URL: https://svnweb.freebsd.org/changeset/base/323331

Log:
  MFC r323002: zfs: do not advertise unsupported hash algorithms

  illumos 4185 ("add new cryptographic checksums to ZFS: SHA-512, Skein,
  Edon-R") was intentionally merged only partially in r289422, without
  adding support for skein, sha512 and edonr on FreeBSD.

  Support for skein and sha512 was added later on (in head), but none of
  these are supported in stable/10. Prior to this commit zfs(8) correctly
  rejected these algorithms, but with an error message that claimed
  support:

  fk@r500 ~ $zfs set checksum=edonr tank
  cannot set property for 'tank': 'checksum' must be one of 'on | off |
    fletcher2 | fletcher4 | sha256 | sha512 | skein | edonr'

  (This commit removes sha512 and skein in addition to edonr from the
  merge of head's r323002.)

  PR:		204055
  Submitted by:	Fabian Keil
  Approved by:	re (kib)
  Obtained from:	ElectroBSD

Changes:
_U  stable/10/
  stable/10/sys/cddl/contrib/opensolaris/common/zfs/zfs_prop.c
Comment 6 Eitan Adler freebsd_committer freebsd_triage 2018-05-23 10:27:57 UTC
batch change of PRs untouched in 2018 marked "in progress" back to open.
Comment 7 Ed Maste freebsd_committer 2018-05-23 14:03:58 UTC
mav merged to stable/11 in r329482